VERSION 5.00
Begin VB.UserControl Line_3D 
   AutoRedraw      =   -1  'True
   BackStyle       =   0  'Transparent
   CanGetFocus     =   0   'False
   ClientHeight    =   135
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4140
   PropertyPages   =   "Line_3D.ctx":0000
   ScaleHeight     =   135
   ScaleWidth      =   4140
   ToolboxBitmap   =   "Line_3D.ctx":000C
   Begin VB.Line LineBackward 
      BorderWidth     =   3
      X1              =   270
      X2              =   3090
      Y1              =   90
      Y2              =   90
   End
   Begin VB.Line LineForward 
      BorderWidth     =   3
      X1              =   240
      X2              =   3060
      Y1              =   60
      Y2              =   60
   End
End
Attribute VB_Name = "Line_3D"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Public Enum Styles
  Normal
  [Normal Border]
  Embossed
  Border
  [Line In Between]
  [Reverse Line In Between]
  [Reverse Thick]
  [Reverse Thinner]
  Bar
  Dash
  Dotted
  [Dash Dot]
  [Dast Dot Dot]
End Enum

Dim LineStyle As Styles

Public Property Let Style(ByVal NewValue As Styles)
  LineStyle = NewValue
  ResizeLines (NewValue)
  PropertyChanged "Style"
End Property

Public Property Get Style() As Styles
  Style = LineStyle
End Property

Private Sub UserControl_Resize()
  LineForward.X2 = UserControl.ScaleWidth - 30
  LineBackward.X2 = UserControl.ScaleWidth - 60
  UserControl.Height = 100
End Sub

Public Property Get BackColor() As OLE_COLOR
  BackColor = LineBackward.BorderColor
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
  LineBackward.BorderColor() = New_BackColor
  UserControl.Refresh
  PropertyChanged "BackColor"
End Property

Public Property Get ForeColor() As OLE_COLOR
  ForeColor = LineForward.BorderColor
End Property

Public Property Let ForeColor(ByVal New_ForeColor As OLE_COLOR)
  LineForward.BorderColor() = New_ForeColor
  PropertyChanged "ForeColor"
End Property

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
  LineBackward.BorderColor = PropBag.ReadProperty("BackColor", 0)
  LineForward.BorderColor = PropBag.ReadProperty("ForeColor", 0)
  
    
  LineStyle = PropBag.ReadProperty("Style", 0)
  ResizeLines (LineStyle)
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
  
  Call PropBag.WriteProperty("BackColor", LineBackward.BorderColor, 0)
  Call PropBag.WriteProperty("ForeColor", LineForward.BorderColor, 0)
  Call PropBag.WriteProperty("Style", LineStyle, 0)
End Sub

Private Function ResizeLines(N As Styles)
  Select Case N
  Case Styles.Normal:
    LineBackward.BorderWidth = 2
    LineBackward.Y1 = 60
    LineBackward.Y2 = 60
    LineBackward.X1 = 30
    LineBackward.X2 = UserControl.ScaleWidth - 30
    
'    LineForward.BorderStyle = 1
    LineForward.BorderWidth = 3
    LineForward.Y1 = 30
    LineForward.Y2 = 30
    LineForward.X1 = 30
    LineForward.X2 = UserControl.ScaleWidth - 30
    LineForward.ZOrder 0
    UserControl.Refresh
  
  Case Styles.[Normal Border]:
    LineBackward.BorderWidth = 5
    LineBackward.Y1 = 30
    LineBackward.Y2 = 30
    LineBackward.X1 = 30
    LineBackward.X2 = UserControl.ScaleWidth - 30
    
'    LineForward.BorderStyle = 1
    LineForward.BorderWidth = 3
    LineForward.Y1 = 37
    LineForward.Y2 = 37
    LineForward.X1 = 30
    LineForward.X2 = UserControl.ScaleWidth - 30
    LineForward.ZOrder 0
    UserControl.Refresh
  
  Case Styles.Embossed:
    LineBackward.BorderWidth = 7
    LineBackward.Y1 = 30
    LineBackward.Y2 = 30
    LineBackward.X1 = 30
    LineBackward.X2 = UserControl.ScaleWidth - 30
    
'    LineForward.BorderStyle = 1
    LineForward.BorderWidth = 5
    LineForward.Y1 = 40
    LineForward.Y2 = 40
    LineForward.X1 = 30
    LineForward.X2 = UserControl.ScaleWidth - 30
    LineForward.ZOrder 0
    UserControl.Refresh
  
  Case Styles.Border:
    LineBackward.BorderWidth = 4
    LineBackward.Y1 = 30
    LineBackward.Y2 = 30
    LineBackward.X1 = 30
    LineBackward.X2 = UserControl.ScaleWidth - 30
    
'    LineForward.BorderStyle = 1
    LineForward.BorderWidth = 2
    LineForward.Y1 = 30
    LineForward.Y2 = 30
    LineForward.X1 = 30
    LineForward.X2 = UserControl.ScaleWidth - 30
    LineForward.ZOrder 0
    UserControl.Refresh
  
  Case Styles.[Line In Between]:
    LineBackward.BorderWidth = 5
    LineBackward.Y1 = 30
    LineBackward.Y2 = 30
    LineBackward.X1 = 30
    LineBackward.X2 = UserControl.ScaleWidth - 30
    
'    LineForward.BorderStyle = 1
    LineForward.BorderWidth = 1
    LineForward.Y1 = 30
    LineForward.Y2 = 30
    LineForward.X1 = 30
    LineForward.X2 = UserControl.ScaleWidth - 30
    LineForward.ZOrder 0
    UserControl.Refresh
  
  Case Styles.[Reverse Line In Between]:
    LineBackward.BorderWidth = 1
    LineBackward.Y1 = 30
    LineBackward.Y2 = 30
    LineBackward.X1 = 30
    LineBackward.X2 = UserControl.ScaleWidth - 30
    
'    LineForward.BorderStyle = 1
    LineForward.BorderWidth = 5
    LineForward.Y1 = 30
    LineForward.Y2 = 30
    LineForward.X1 = 30
    LineForward.X2 = UserControl.ScaleWidth - 30
    LineForward.ZOrder 1
    UserControl.Refresh
    
  Case Styles.[Reverse Thick]:
    LineBackward.BorderWidth = 3
    LineBackward.Y1 = 30
    LineBackward.Y2 = 30
    LineBackward.X1 = 30
    LineBackward.X2 = UserControl.ScaleWidth - 30
    
'    LineForward.BorderStyle = 1
    LineForward.BorderWidth = 5
    LineForward.Y1 = 30
    LineForward.Y2 = 30
    LineForward.X1 = 30
    LineForward.X2 = UserControl.ScaleWidth - 30
    LineForward.ZOrder 1
    UserControl.Refresh
  
  Case Styles.[Reverse Thinner]:
    LineBackward.BorderWidth = 2
    LineBackward.Y1 = 30
    LineBackward.Y2 = 30
    LineBackward.X1 = 30
    LineBackward.X2 = UserControl.ScaleWidth - 30
    
'    LineForward.BorderStyle = 1
    LineForward.BorderWidth = 4
    LineForward.Y1 = 30
    LineForward.Y2 = 30
    LineForward.X1 = 30
    LineForward.X2 = UserControl.ScaleWidth - 30
    LineForward.ZOrder 1
    UserControl.Refresh
  
  Case Styles.Bar:
    LineBackward.BorderWidth = 3
    LineBackward.Y1 = 30
    LineBackward.Y2 = 30
    LineBackward.X1 = 0
    LineBackward.X2 = UserControl.ScaleWidth - 90
    
'    LineForward.BorderStyle = 1
    LineForward.BorderWidth = 3
    LineForward.Y1 = 60
    LineForward.Y2 = 60
    LineForward.X1 = 60
    LineForward.X2 = UserControl.ScaleWidth
    LineForward.ZOrder 0
    UserControl.Refresh
    
  Case Styles.Dash:
    LineBackward.BorderWidth = 3
    LineBackward.Y1 = 30
    LineBackward.Y2 = 30
    LineBackward.X1 = 0
    LineBackward.X2 = UserControl.ScaleWidth - 30
    
    LineForward.BorderWidth = 1
    LineForward.BorderStyle = 2
    LineForward.Y1 = 30
    LineForward.Y2 = 30
    LineForward.X1 = 30
    LineForward.X2 = UserControl.ScaleWidth - 30
    LineForward.ZOrder 0
    UserControl.Refresh
    
  Case Styles.Dotted:
    LineBackward.BorderWidth = 3
    LineBackward.Y1 = 30
    LineBackward.Y2 = 30
    LineBackward.X1 = 0
    LineBackward.X2 = UserControl.ScaleWidth - 30
    
    LineForward.BorderWidth = 1
    LineForward.BorderStyle = 3
    LineForward.Y1 = 30
    LineForward.Y2 = 30
    LineForward.X1 = 30
    LineForward.X2 = UserControl.ScaleWidth - 30
    LineForward.ZOrder 0
    UserControl.Refresh

  Case Styles.[Dash Dot]:
    LineBackward.BorderWidth = 3
    LineBackward.Y1 = 30
    LineBackward.Y2 = 30
    LineBackward.X1 = 0
    LineBackward.X2 = UserControl.ScaleWidth - 30
    
    LineForward.BorderWidth = 1
    LineForward.BorderStyle = 4
    LineForward.Y1 = 30
    LineForward.Y2 = 30
    LineForward.X1 = 30
    LineForward.X2 = UserControl.ScaleWidth - 30
    LineForward.ZOrder 0
    UserControl.Refresh

  Case Styles.[Dast Dot Dot]:
    LineBackward.BorderWidth = 3
    LineBackward.Y1 = 30
    LineBackward.Y2 = 30
    LineBackward.X1 = 0
    LineBackward.X2 = UserControl.ScaleWidth - 30
    
    LineForward.BorderWidth = 1
    LineForward.BorderStyle = 5
    LineForward.Y1 = 30
    LineForward.Y2 = 30
    LineForward.X1 = 30
    LineForward.X2 = UserControl.ScaleWidth - 30
    LineForward.ZOrder 0
    UserControl.Refresh

  End Select
End Function
